 /**
 * The Pair specification for pairs of Elements of the same type.
 * 
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 * 
 * @author Gloss
 * @version 1.0 - 27/Nov/2012
 **/
specification Pair[Element]

	sorts
		Pair[Element]
		
	constructors
		make : Element Element --> Pair[Element];
		
	observers
		first: Pair[Element] --> Element;
		second: Pair[Element] --> Element;
		symmetric: Pair[Element] --> Pair[Element];
		
	axioms
	    E, F: Element; 
	    
		first(make(E,F)) = E;	
		
		second(make(E,F)) = F;
		
		symmetric(make(E,F)) = make(F,E);	

end specification
