import java.util.Random;

/**
 * A class that implements the test for MyPair class.
 * 
 * @author Gloss
 * @version 1.1 - 12/Jul/2013 asantos
 **/
public class MyPairRandomTest {
	
	/**
	 * Pair object.
	 **/
	private MyPair<Integer> pair;

	/**
	 * How many tests do we want to perform.
	 **/
	private int howMany;

	/**
	 * Max operations.
	 **/
	private static int MAX_OPERATIONS = 5;

	/**
	 * Our random object to generate random int.
	 **/
	private Random rand;
	
	/**
	 * Max value of integers created for pairs
	 **/
	private static int MAX_INTEGER = 100;


	/**
	 * Constructor.
	 * 
	 * @param pair - the pair to be tested.
	 * @param howMany - how many tests we want to perform.
	 **/
	public MyPairRandomTest(MyPair<Integer> pair, int howMany) {
		this.pair = pair;
		this.howMany = howMany;
		this.rand = new Random();
	}

	/**
	 * Runs the tests.
	 **/
	public void run() {
		
		MyPair<Integer> newPair = null;
		
		for (int i = 0; i < howMany; i++) {
			
			switch (rand.nextInt(MAX_OPERATIONS)) {
				// show pair.
				case 0: 
					System.out.println("The pair is " + pair.toString());
					break;
							
				// get the pair first element.
				case 1: 
					System.out.println("The pair first element is " 
				                       + pair.getFst());
					break;
	
				// get the pair second element.
				case 2: 
					System.out.println("The pair second element is " 
				                       + pair.getScnd());
					break;
	
				// are the pairs equal?
				case 3: 
					newPair = newPair();
					System.out.println("Pair " + pair.toString());
					System.out.println("newPair " + newPair.toString());
					System.out.println("The pairs are" + 
					          (pair.equals(newPair)? " ":" not ") + "equal");
					break;
				
				// invert pair.
				case 4: 
					System.out.println("Getting a new inverted pair ...");
					newPair = pair.getSym();
					System.out.println("Pair " + pair.toString());
					System.out.println("Inverted pair " + newPair.toString());
					break;
			}
			System.out.println();	
		}
	}

	/**
	 * Creates a new Pair.
	 * 
	 * @return a new Pair.
	 **/
	private MyPair<Integer> newPair() {
		int firstElem = rand.nextInt(MAX_INTEGER);
		int secondElem = rand.nextInt(MAX_INTEGER);
		return new MyPair<Integer>(firstElem, secondElem); 
		
	}
}
